% Test for winFFT2

% Instructions:
% 1. Edit the ShakerCalcFRF() function by setting testMode = TRUE
%    (first line in function)
% 2. Run this script; it will overwrite the first data channel in a shaker
%    file with a copy of the force signal filtered with a band pass filter
%    (testBPF) and output a file called SHKR_modFile.mat.
% 3. Run ShakerCalcFRF() on the file SHKR_modFile.mat.
% 4. Run plotFRF() on the file generated by ShakerCalcFRF().

% load a real shaker file to start with
load('SHKR_20150413_19_03_04.mat');

fs = sh.fs;     % sample frequency (Hz)
t = sh.time;    % time vector
c=sqrt(2); % 1V RMS
rng('shuffle'); % random seed for random number generator

[numRows,numCols] = size(sh.data);

%f = sh.data(:,numCols-1); % real force vector
f = 1e-6 * (rand(numRows,1) - 0.5); % tiny noise force vector (can't = 0)
%f = chirp(t,5,t(end,1),500); % artificial force vector
f = f+c*sin(2*pi*10*t)+c*sin(2*pi*20*t)+c*sin(2*pi*30*t)+c*sin(2*pi*40*t);

r = zeros(1,numRows); % zero amplitude response vector

 %{
% add a blob of coherent data to response vector
% set parameters here
ampltd = 1; % amplitude of signal
fc1 = 40; % First Cutoff Frequency (Hz)
fc2 = 50; % Second Cutoff Frequency (Hz)
Hd = testBPF(fc1,fc2,fs); % create filter object
r = ampltd * filter(Hd,f); % add to response vector
 %}

% add non-coherent sine waves
r = c*sin(2*pi*10*t)+0.1*c*sin(2*pi*20*t)+0.01*c*sin(2*pi*30*t)+0.001*c*sin(2*pi*40*t);
%+ sin(2*pi*15*t) + sin(2*pi*20*t);

%{
% add noise
noiseAmp = 1e-6; % noise amplitude
rng('shuffle');
r = r + noiseAmp * (rand(numRows,1) - 0.5);
%}

%{
% add a non-coherent chirp
chrpSt = 0; % chirp start freq (time 0)
chrpEn = 100; % chirp end freq
stIdx = floor(numRows * 0.8125); % start time set 0 to 1
enIdx = floor(numRows * 0.9); % stop time set 0 to 1 (larger that stIdx)
chrpTim = (enIdx - stIdx) / fs;
r(stIdx:enIdx,1) = r(stIdx:enIdx,1) +...
    1 * chirp(t(stIdx:enIdx,1),chrpSt,t(enIdx,1),chrpEn);
%}

%{
sh.data(:,1) = r;
sh.data(:,numCols-1) = f;
%}

%{
figure(36);
plot(sh.time, f)
hold on;
plot(sh.time, sh.data(:,1))
legend('force channel','response channel')
%}

fres = 0.01;
winType = 'HFT90D';
spType = 'PSD';
[dat,fvec,s] = winFFT2(r,fs,fres,winType,spType);

figure;
semilogy(fvec,dat)

%save('SHKR_testFile.mat','sh');
clear a f fc1 fc2 fs Hd numCols numRows sh t ulsb noiseAmp r c
%ShakerCalcFRF('SHKR_testFile.mat'); % freq domain analysis routine
%plotFRF2(0,50,1e-12,2e3,'TestOut.mat'); % plot routine
%legend(gca,'off');
%title(gca,'Coherent Chirp 40-50Hz A=1, Non-Coherent Chirp 90-100Hz A=1, Noise A=1e^{-3}, sines A=1');
%title(gca,'Sines 10,15,20Hz 1pk, fres=0.01Hz, win=HFT248D');
%ylabel(gca,'Force Response Function - test mode','FontAngle','Italic');

